extends KinematicBody2D

const corpse_scene = preload("res://AuxiliaryScenes/PlayerCorpse.tscn")

export var spawn_point = Vector2()

const UP = Vector2(0, -1)
const GRAVITY = 30
const ACCELERATION = 20
const MAX_SPEED = 160
const JUMP_HEIGHT = -500

var motion = Vector2()
var death = false
var is_dead = false
signal pressed
signal erect
signal impaled
signal camera_entered
signal camera_exited

func change_state():
	death = false

func _physics_process(delta):
#	print(spawn_point)
	motion.y += GRAVITY
	var friction = false
	
	if Input.is_action_pressed("ui_right"):
		motion.x = min(motion.x + ACCELERATION, MAX_SPEED)
		$Sprite.flip_h = false
		$Sprite.play("Walk")
	elif Input.is_action_pressed("ui_left"):
		motion.x = max(motion.x - ACCELERATION, -MAX_SPEED)
		$Sprite.flip_h = true
		$Sprite.play("Walk")
	else:
		friction = true
		motion.x = lerp(motion.x, 0, 0.2)
		$Sprite.play("Idle")
	
	if is_on_floor():
		if Input.is_action_pressed("ui_up"):
			motion.y = JUMP_HEIGHT
		if friction == true:
			motion.x = lerp(motion.x, 0, 0.2)
	else:
		if motion.y < 0:
			$Sprite.play("Jump")
		else:
			$Sprite.play("Fall")
		if friction == true:
			motion.x = lerp(motion.x, 0, 0.05)
	
	motion = move_and_slide(motion, UP)
	
	pass

func _death():
	var corpse = corpse_scene.instance()
	corpse.set_position(position + Vector2(0, 10))
	get_tree().get_root().add_child(corpse)
	position = spawn_point

func _impaled():
	position = spawn_point
	death = false

func _on_Scorch_body_entered(body):
	if body.get_name() == "Player":
		if not death:
			_impaled()
			emit_signal("impaled")
			death = true

func _on_Button_body_entered(body):
	emit_signal("pressed")

func _on_Button_body_exited(body):
	emit_signal("erect")

func _on_Camera_body_entered(body):
	emit_signal("camera_entered")

func _on_Camera_body_exited(body):
	emit_signal("camera_exited")

func _on_Scorch_body_exited(body):
	pass # Replace with function body.